/* BinaryTree.java
 *
 * 2009 yz
 */

import java.io.*;

public class BinaryTree {
    private static final int PREORDER = 0;
    private static final int INORDER = 1;
    private static final int POSTORDER = 2;
    
    private static class Node {
	public int data;
	public Node left;
	public Node right;
	
	public Node(int i) {
	    data = i;
	    left = null;
	    right = null;
	}
    }
    
    private static class BTree {
	private Node root;
	
	public BTree() {
	    root = null;
	}
	
	private Node insert(Node node, int data) {
	    if(node == null) {
		node = new Node(data);
	    } else {
		if(data <= node.data)
		    node.left = insert(node.left, data);
		else
		    node.right = insert(node.right, data);
	    }
	    
	    return node;
	}
	
	public void insert(int data) {
	    root = insert(root, data);
	}
	
	private void print(Node node, int type) {
	    if(node != null) {
		
		switch(type) {
		case PREORDER:
		    System.out.print(node.data + " ");
		    print(node.left, type);
		    print(node.right, type);
		    break;
		case INORDER:
		    print(node.left, type);
		    System.out.print(node.data + " ");
		    print(node.right, type);
		    break;
		case POSTORDER:
		    print(node.left, type);
		    print(node.right, type);
		    System.out.print(node.data + " ");
		    break;
		}
	    }
	}
	
	public void print(int type) {
	    print(root, type);
	}
    }
    
    public static void main(String[] args) {
	BTree tree = new BTree();
	
	for(int i = 0; i < 9; i++)
	    tree.insert(i);
	
	System.out.print("preorder print : ");
	tree.print(PREORDER);
	System.out.println();
	System.out.print("inorder print : ");
	tree.print(INORDER);
	System.out.println();
	System.out.print("postorder print : ");
	tree.print(POSTORDER);
	System.out.println();
    }
}
