/* binaryTree.c
 *
 * 2009 yz
 */

#include <stdio.h>
#include <stdlib.h>

enum printType {
  preorder,
  inorder,
  postorder
};

typedef struct node {
  int data;
  struct node *left;
  struct node *right;
} Node;

Node *insert(Node *node, int data) {
  if(node == NULL) {
    node = (Node *)malloc(sizeof(Node));
    node->data = data;
    node->left = NULL;
    node->right = NULL;
  } else {
    if(data <= node->data)
      node->left = insert(node->left, data);
    else
      node->right = insert(node->right, data);
  }
  
  return node;
}

void print(Node *node, int type) {
  if(node != NULL) {
    switch(type) {
    case preorder:
      printf("%d ", node->data);
      print(node->left, type);
      print(node->right, type);
      break;
    case inorder:
      print(node->left, type);
      printf("%d ", node->data);
      print(node->right, type);
      break;
    case postorder:
      print(node->left, type);
      print(node->right, type);
      printf("%d ", node->data);
      break;
    }
  }
}

int main(void) {
  Node *root;
  int i;
  
  root = NULL;
  for(i = 0; i < 9; i++)
    root = insert(root, i);
  
  printf("preorder print : ");
  print(root, preorder);
  printf("\n");
  
  printf("inorder print : ");
  print(root, inorder);
  printf("\n");
  
  printf("postorder print : ");
  print(root, postorder);
  printf("\n");
  
  return 0;
}
