/* binaryTree.cpp
 *
 * 2009 yz
 */

#include <iostream>

using namespace std;

enum printType {
  preorder,
  inorder,
  postorder
};

class Node {
public:
  int data;
  Node *left;
  Node *right;
  
  Node(int i) {
    data = i;
    left = NULL;
    right = NULL;
  }
};

class BTree {
private:
  Node *root;
  
  Node *insert(Node *node, int data) {
    if(node == NULL) {
      node = new Node(data);
    } else {
      if(data <= node->data)
	node->left = insert(node->left, data);
      else
	node->right = insert(node->right, data);
    }
    
    return node;
  }
  
  void print(Node *node, int type) {
    if(node != NULL) {
      switch(type) {
      case preorder:
	cout << node->data << " ";
	print(node->left, type);
	print(node->right, type);
	break;
      case inorder:
	print(node->left, type);
	cout << node->data << " ";
	print(node->right, type);
	break;
      case postorder:
	print(node->left, type);
	print(node->right, type);
	cout << node->data << " ";
	break;
      }
    }
  }
  
public:
  BTree() {
    root = NULL;
  }
  
  void insert(int data) {
    root = insert(root, data);
  }
  
  void print(int type) {
    print(root, type);
  }
};

int main(void) {
  BTree tree;
  
  for(int i = 0; i < 9; i++)
    tree.insert(i);
  
  cout << "preorder print : ";
  tree.print(preorder);
  cout << endl;
  cout << "inorder print : ";
  tree.print(inorder);
  cout << endl;
  cout << "postorder print : ";
  tree.print(postorder);
  cout << endl;
  
  return 0;
}
